/**********************************************************************************
 * Copyright (c) 2021 Process Systems Engineering (AVT.SVT), RWTH Aachen University
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 **********************************************************************************/
#pragma once

#include "gurobi_c++.h"
#include <vector>
#include <numeric>
#include <algorithm>
#include <functional>
#include "exceptions.hpp"
#include "inputStructs.hpp"
#include "dynArrayRaiiWrapper.hpp"

//Subproblem class to provide an interface for the main program when solving SP and adding cuts
class PlantbusSubproblem {
	SubproblemOptions options_; //waiving const to keep it movable
	GRBModel model_; //GRBModels do not provide move operations
	DynArrayRAIIWrapper<GRBConstr> equations_; //waiving const to keep it movable
	DynArrayRAIIWrapper<GRBVar> variables_; //waiving const to keep it movable
	std::string coupling_equation_name_; //waiving const to keep it movable

	//vectors of indices, waived const to keep them movable (const would require init from InitObject via delegating c'tor)
	std::vector<int> coupling_equation_; 
	std::vector<int> constraints_;
	std::vector<int> model_vars_;
	std::vector<int> n_slack_;
	std::vector<int> p_slack_;

	// using const for trivially copyable members as move is throwing due to non-movable GRBModel
	const unsigned num_timesteps_;
	std::vector<double> pow_sugg_;
	const double plant_load_;

	//Number of records of the subproblem model required for computing scalar products later on
	const unsigned long rhs_num_records_;

	unsigned long InitObject();

public:
	//Constructor initializes SP model
	PlantbusSubproblem(const GRBEnv& env, const std::string& option_path, const double plant_load, const unsigned num_timesteps);

	void Solve();

	int GetModelStatus() const;

	//Generalized version to compute rhs of the cut generated by this subproblem
	double GetNewRhs() const;

	//Computes the value of the lhs of the subproblem cut given the last power profile
	double GetCurrLhs() const;

	//Computes the coefficient of the new cut generated by the subproblem for a given time
	double GetNewCoeff(const unsigned key) const;

	std::vector<double> GetNewCoeffs() const;

	double GetSubproblemObjective() const;

	double GenerateAndVerifyCut() const;

	double get_feas_distance() const;

	std::vector<double> get_feas_sol() const;

	double get_feas_sol(const unsigned key) const;

	double get_plant_load() const;

	std::vector<double> GetNSlackValues() const;

	std::vector<double> GetPSlackValues() const;

	std::vector<double> get_pow_sugg() const;

	double get_pow_sugg(const unsigned i) const;

	void set_pow_sugg(const std::vector<double>& in);

	void set_pow_sugg(const unsigned key, const double val);

	GRBModel& GetModel();
};